#include <string.h>

%IF_HAS_BOOL%// The array of all boolean signals.
%IF_HAS_BOOL%bool %BOOL_VECTOR%[%NUMBER_BOOL%];

%IF_HAS_INT%// The array of all integer signals.
%IF_HAS_INT%int %INT_VECTOR%[%NUMBER_INT%];

%IF_HAS_REAL%// The array of all real-valued signals.
%IF_HAS_REAL%float %REAL_VECTOR%[%NUMBER_REAL%];

// The RTflow model names of all boolean signals, terminated by NULL.
const char* const boolNames[%NUMBER_BOOL%+1] =
{
   "%BOOL_NAMES%",
   NULL
};

// The RTflow model names of all integer signals, terminated by NULL.
const char* const intNames[%NUMBER_INT%+1] =
{
   "%INT_NAMES%",
   NULL
};

// The RTflow model names of all real-valued signals, terminated by NULL.
const char* const realNames[%NUMBER_REAL%+1] =
{
   "%REAL_NAMES%",
   NULL
};

%IF_HAS_BOOL%// Returns the array of all boolean signals.
%IF_HAS_BOOL%bool* getBoolArray() { return %BOOL_VECTOR%; }

%IF_HAS_INT%// Returns the array of all integer signals.
%IF_HAS_INT%int* getIntArray() { return %INT_VECTOR%; }

%IF_HAS_REAL%// Returns the array of all real-valued signals.
%IF_HAS_REAL%float* getRealArray() { return %REAL_VECTOR%; }

// Returns the real time in seconds corresponding to one execution cycle.
float GetSampleTime(void)
{
   return (float)%SAMPLE_TIME%;
}

// Initializes the state of the system. Call this function once before
// calling run().
void Initialize(void)
{
   %INITIAL_EQUATIONS%
}

// Executes one cycle. Every cycle, the calling code should:
// 1) Provide the input signal values by writing into the arrays.
// 2) Call the run() funcstion.
// 3) Collect the output signal values by reading from the arrays.
void Run(void)
{
   // Output update equations
   %OUTPUT_UPDATE_EQUATIONS%

   // State update equations
   %STATE_UPDATE_EQUATIONS%
}

// Finds the index of a signal given its name. The calling code can
// use this function to retrieve the index to be used when reading
// or writing in an array for a specific signal.
// Parameter names: The array of names to search; either boolNames, intNames or realNames.
// Parameter name: The name of the signal to find the index for.
// Returns the index of the requested signal, or -1 if not found.
int FindName(const char* const* names, const char* name)
{
   for (int i = 0; names[i] != NULL; i++)
   {
      if (strcmp(names[i], name) == 0)
      {
         return i;
      }
   }
   return -1;
}	
